//<c>   Copyright 1984-1998 by Gerry J. Danen; all rights reserved.

//<t>   Change File Attributes

//      Compiled with Microsoft C 8.00. Requires DANEN library to recompile.
//      Source released into the Public Domain.

#include"gd_tools.h"
#include"gd_extrn.h"
#include"gd_files.h"
#include"gd_mouse.h"
#include"gd_kb.h"
#include"gd_scrn.h"


#if     (! LARGE_MODEL)
  #error LARGE MEMORY MODEL REQUIRED
#endif


#define pgVERS_ "V5.00"
#define pgTITL_ "Change File Attributes"
#define pgCOPR_ "1984"


#define         DIR_MAX 700                     // maximum dir. entries
DIRLIST         *eDir[ DIR_MAX + 1 ] ;          // directory entries
SUBDIR          hDir ;                          // directory header
extern  INT16   marked_entries  ;               // # of marked entries


INT16           set_att[5] = { 0, 0, 0, 0, 0 }; // 1=ro, 2=hi, 3=sy, 4=ar


UCHAR           *fatr_menu[] =  {
                "Read-only",    "On = write-protected; Off = writing allowed",
                "Hidden",       "Hide files from directory searches",
                "System",       "Mark file as system file",
                "Archive",      "On allows BACKUP to select the file",
                "Directory",    "Select files to be changed (Resets marked files!)",
                "Go",           "Change the marked files according to the selected attribute pattern",
                "Quit",         "Quit from this menu",
                "" };

UCHAR           *fatr_menu1[] = {
                "Set",          "Turn the attribute on",
                "Remove",       "Turn the attribute off",
                "Leave",        "Leave the attribute as it is (don't set or remove)",
                "" };


void    status_attr_mode( void )
{
    INT16       i, fg, m1, m2 ;
    UCHAR       msg[ STR_LEN ] ;

    DIR_ret_filespec( msg );
    if ( marked_entries )
        fg = YELLOW ;
    else
        fg = vid.normal_fg ;
    LOOP( i, 1, 4, 1 )
    {
        m1 = (i-1) * 2 ;
        switch ( set_att[ i ] )
        {
            case 1 :
                m2 = 0 ;
                break ;
            case -1:
                m2 = 2 ;
                break ;
            default:
                m2 = 4 ;
                break ;
        }
        DspMessage( i+19, 2, fg, vid.normal_bg, "%-9s - %s", fatr_menu[ m1 ], fatr_menu1[ m2 ] );
    }
    DspMessage( 23, 41, fg, vid.normal_bg, "%d files marked for change", marked_entries );
    DIR_ret_filespec( msg );
    DspMessage( 22, 41, fg, vid.normal_bg, msg );
}


void    set_attr_mode( INT16 which )
{
    INT16       col, choice, start_choice ;

    switch ( which )
    {
        case 2 :
            col = 12 ;
            break ;
        case 3 :
            col = 20 ;
            break ;
        case 4 :
            col = 28 ;
            break ;
        default:
            col = 1 ;
    }
    switch ( set_att[which] )
    {
        case 1 :
            start_choice = 1 ;
            break ;
        case -1:
            start_choice = 2 ;
            break ;
        default:
            start_choice = 3 ;
    }
    choice = ShowMenu( PULLDOWN_MENU_TYPE, fatr_menu1, NO, 0, col, &start_choice );
    switch ( choice )
    {
        case 1 :
            set_att[which] = 1 ;
            break ;
        case 2 :
            set_att[which] = -1 ;
            break ;
        case 3 :
            set_att[which] = 0 ;
    }
}


void    set_attr_go( void )
{
    UCHAR       ext[4], pathname[MAX_PATH_LEN+12] ;
    INT16       i ;

    if ( marked_entries )
    {
        NewScreen();
        printf( "\nChanging %d files\n", marked_entries );
// printf( "in list: %d files\n", hDir.entries );
        LOOP( i, 1, hDir.entries, 1 )
        {
            if ( eDir[i]->marked )
            {
                st_cpy( ext, eDir[i]->ext, 4 );
                st_trim( ext );
                if ( strlen(ext) )
                    sprintf( pathname, "%s%s.%s", hDir.path, eDir[i]->name, ext );
                else
                    sprintf( pathname, "%s%s", hDir.path, eDir[i]->name );
                printf( "\n%s", pathname );
                if ( eDir[i]->at_sub_dir )
                    printf( " <dir>" );
                SetAttrib( pathname, set_att[1], set_att[2], set_att[3], set_att[4] );
            }
        }
        CursOn();
        sn_beep();
        printf( "\n\nPress any key to continue..." );
        kb_getkey_();
        CursOff();
        cls();
    }
    else
        sn_beep();
}


void    main( int argc, char *argv[] )
{
    UCHAR       filespec[MAX_PATH_LEN+12] ;     // file specification
    INT16       ercode ;                        // error return code
    UCHAR       *mark_msg = "Select files to change:" ;
    INT16       choice, start_choice=1 ;

    fs_init( FALSE, SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    Allow_Break();                              // allow ^Break to abort
    ms_init();
    SetMenuAuto( TRUE );
    ercode = DIR_init( DIR_MAX, &hDir, eDir );
    if ( argc == 1 )
        DIR_set_filespec( "*.*" );
    else
        DIR_set_filespec( argv[1] );
    DIR_ret_filespec( filespec );
    DIR_find( &hDir, eDir, filespec, (REGULAR_FILES|_A_SUBDIR) );
    FOREVER
    {
        NewScreen();
        status_attr_mode();
        choice = ShowMenu( SLASH_MENU_TYPE, fatr_menu, NO, 0, 0, &start_choice );
        switch ( choice )
        {
            case 1 :
            case 2 :
            case 3 :
            case 4 :
                set_attr_mode( choice );
                break ;
            case 5 :
                DIR_ret_filespec( filespec );
                ercode = DIR_find( &hDir, eDir, filespec, (REGULAR_FILES|_A_SUBDIR) );
                DIR_show( &hDir, eDir, mark_msg, ercode, 2 );
                break ;
            case 6 :
                set_attr_go();
                break ;
            case 0 :
            case 7 :
                NewScreen();
//              credits( "Contact us for other Productivity Software" );
//              st_shareware( "$15.00" );
                DIR_exit( eDir );
                gd_exit( 0, "" );
        }
    }
}
